﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class Insert_Select_Control : UserControl
	{
		private Timer _timer;
		private int _idx;
		private Random _rnd;

		public Insert_Select_Control(int startIdx)
		{
			InitializeComponent();

			InitInstance(startIdx);
		}

		private void InitInstance(int startIdx)
		{
			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}

			_idx = startIdx;
			_rnd = new Random();
			_timer = new Timer();
			_timer.Interval = 5 * 1000;
			_timer.Tick += timer_Tick;
			timer_Tick(null, null);
			_timer.Start();
		}

		private void BindTableToGridView(DataTable table)
		{
			mainGridView.SuspendLayout();
			mainGridView.DataSource = table;
			mainGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
			mainGridView.ResumeLayout();
		}

		private void DoWork()
		{
			AdoClient.Instance.NonQuery($"INSERT INTO EMPLOYEE (ENO, ENAME, JOB, HIREDATE) VALUES ({_idx++}, 'e{_rnd.Next(1, 1000)}', 'tester', '{DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")}')");

			DataSet dataSet = AdoClient.Instance.Query("SELECT * FROM EMPLOYEE");
			BindTableToGridView(dataSet.Tables[0]);
		}

		private void timer_Tick(object sender, EventArgs e)
		{
			DoWork();
		}
	}
}
